/* file      : TreeToolObserver.java
 * purpose   : an interface (or abstract base class) for a 
 *             TreeToolObserver - a class representing objects
 *             interested in changes of a Tree structure
 * author    : Thomas Koch
 * copyright : 1995 , GMD 
 *            (Forschungszentrum Informationstechnik GmbH, FIT.CSCW,
 *             GMD Schloss Birlinghoven, 53754 Sankt Augustin, Germany).
 */

package ui.tree;

import java.lang.*;
import java.util.*;
import java.awt.*;
import ui.tree.*;

public interface TreeToolObserver
{
  public void nodeSelected(TreeNode node);
  public void nodeUnSelected(TreeNode node);
  public void nodeOpened(TreeNode node);
  public void nodeClosed(TreeNode node);
  public void nodeAdded(TreeNode where,TreeNode node);
  public void nodeRemoved(TreeNode node);
}

